<template>
  <v-container>
    <v-row class="text-center">
      <v-col cols="12">
        <v-btn :disabled="loading" @click="toggleWeekends">
          toggle weekends
        </v-btn>

        <div class="relative mt-4">
          <v-progress-circular
            v-if="loading"
            :size="70"
            :width="7"
            color="purple"
            indeterminate
          />
          <full-calendar v-else :options="calendarOptions">
            <template v-slot:eventContent="arg">
              <b>{{ arg.timeText }}</b>
              <i>{{ arg.event.title }}</i>
            </template>
          </full-calendar>
        </div>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import '@fullcalendar/core/vdom' // solves problem with Vite
import FullCalendar from '@fullcalendar/vue'
import dayGridPlugin from '@fullcalendar/daygrid'
import timeGridPlugin from '@fullcalendar/timegrid'
import interactionPlugin from '@fullcalendar/interaction'

export default {
  components: {
    FullCalendar, // make the <FullCalendar> tag available
  },

  data() {
    return {
      loading: false,

      calendarOptions: {
        plugins: [
          dayGridPlugin,
          timeGridPlugin,
          interactionPlugin, // needed for dateClick
        ],
        headerToolbar: {
          left: 'prev,next today',
          center: 'title',
          right: 'dayGridMonth,timeGridWeek,timeGridDay',
        },
        initialView: 'dayGridMonth',
        timeZone: 'UTC',
        events: [],
        editable: true,
        selectable: true,
        selectMirror: true,
        dayMaxEvents: true,
        weekends: true,
        // handle
        select: this.handleDateSelect,
      },

      currentEvents: [],
    }
  },

  async created() {
    this.loading = true

    try {
      const { data } = await this.$axios.get('events')
      this.calendarOptions.events = data.data
    } catch (error) {
      console.error(error)
    }

    this.loading = false
  },

  methods: {
    toggleWeekends() {
      this.calendarOptions.weekends = !this.calendarOptions.weekends // toggle the boolean!
    },

    handleDateSelect(selectInfo) {
      console.log(selectInfo)
      let calendarApi = selectInfo.view.calendar

      calendarApi.unselect() // clear date selection
    },

    handleEventClick(clickInfo) {
      console.log(clickInfo.event.title)
      // clickInfo.event.remove()
    },

    handleEvents(events) {
      this.currentEvents = events
    },
  },
}
</script>
